import pygame,os,time,random

from featherlib.objects import *

class feeding(object):
    def __init__(self,parrot,hand,scene):
        self.scene = scene
        self.parrot = parrot
        self.hand = hand
        self.fed = self.parrot.bowl
        self.delay = 50
        self.hand.pos = [450,235]
        self.bimagepos = [40,25]
        self.bimage = pygame.image.load("parrot-med.png")
        self.bite = pygame.image.load("parrot-med-bite.png")
        self.bitten = 0
        self.bg = pygame.image.load("background.png")
        self.perch = pygame.image.load("perch.png")
        self.bhand = pygame.image.load("bighand.png")
        self.bowl = pygame.image.load("bowl.png")
        self.bowl_pos = [200,372]
        self.oldpos = pygame.mouse.get_pos()
        pygame.event.set_grab(True)
        pygame.mouse.set_pos([470,240])
        self.loop()
        pygame.event.set_grab(False)
        pygame.mouse.set_pos(self.oldpos)
        self.parrot.bowl = self.fed
    def move_hand(self,newpos):
        if newpos[0]>self.hand.pos[0]:
            am = min(newpos[0]-self.hand.pos[0],32)
            self.hand.pos[0]+=am
        if newpos[0]<self.hand.pos[0]:
            am = min(self.hand.pos[0]-newpos[0],32)
            self.hand.pos[0]-=am
        if self.hand.pos[0]>600:
            print "escaped!"
            self.running = False
        collidepoint = [self.hand.pos[0]+72,self.hand.pos[1]+150]
        if collidepoint[0]>self.bowl_pos[0] and collidepoint[0]<self.bowl_pos[0]+self.bowl.get_width():
            if collidepoint[1]>self.bowl_pos[1] and collidepoint[1]<self.bowl_pos[1]+5:
                if self.hand.carried:
                    print "fed the bird"
                    self.fed = self.hand.carried
                    self.hand.carried = None
        self.hand.pos[1] = newpos[1]
    def draw_scaled(self,ob,pos,offset):
        carriedimg = pygame.transform.scale2x(ob.small)
        self.scene.window.blit(carriedimg,[pos[0]-carriedimg.get_width()/2+offset[0],
                                                    pos[1]-carriedimg.get_height()/2+offset[1]])
    def loop(self):
        self.running = True
        clock = pygame.time.Clock()
        while self.running:
            clock.tick(30)
            self.w = self.bimage.get_width()
            self.w += self.bimagepos[0]
            self.scene.window.blit(self.bg,[0,0])
            self.scene.window.blit(self.perch,[0,236])
            if not self.bitten:
                self.scene.window.blit(self.bimage,[self.bimagepos[0],self.bimagepos[1]])
            else:
                self.scene.window.blit(self.bite,[self.bimagepos[0],self.bimagepos[1]])
                self.bitten -= 1
            if self.hand.carried:
                self.draw_scaled(self.hand.carried,self.hand.pos,[72,84])
            self.scene.window.blit(self.bhand,[self.hand.pos[0],self.hand.pos[1]])
            if self.fed:
                self.draw_scaled(self.fed,self.bowl_pos,[101,12])
            self.scene.window.blit(self.bowl,self.bowl_pos)
            pygame.display.flip()
            for e in pygame.event.get():
                if e.type == pygame.QUIT or e.type == pygame.KEYDOWN\
                and e.key == pygame.K_ESCAPE:
                    self.running = False
            self.move_hand(pygame.mouse.get_pos())
            self.delay -= 1
            if self.delay <=0:
                r = random.randint(3,10)
                r2 = 0
                if self.w<255 and self.w>150:
                    r2 = random.randint(1,2)
                if self.w>=250:
                    r2 = 1
                if self.w<=150:
                    r2 = 2
                if r2 == 1:
                    self.bimagepos[0]-=r
                    self.w = self.bimage.get_width()
                    self.w += self.bimagepos[0]
                    if self.w<=150:
                        self.w=150
                if r2 == 2:
                    self.bimagepos[0]+=r
                    self.w = self.bimage.get_width()
                    self.w += self.bimagepos[0]
                    if self.w>=250:
                        self.w = 250
                if r2 == 0:
                    print "uh oh"
                    print self.w
                if self.w>=self.hand.pos[0]:
                    print "bitten"
                    self.bitten = 3
                self.delay = 50