def load_rects(file):
    """Load rectangles out of an inkscape SVG file
    Not really used in this project"""
    rects = []
    import xml.etree.ElementTree as ET
    def matrix(a,b,c,d,e,f):
        return [float(x) for x in [a,b,c,d,e,f]]
    def mmult(point,m):
        nx = m[0]*point[0]+m[2]*point[1]
        ny = m[1]*point[0]+m[3]*point[1]
        return nx,ny
    def transform(x,y,width,height,trans):
        if trans.startswith("matrix"):
            m = eval(trans)
        else:
            return x,y,width,height
        nx,ny = mmult([x,y],m)
        x2 = x+width
        y2 = y+height
        nx2,ny2 = mmult([x2,y2],m)
        nwidth = round(nx2-nx)
        nheight = round(ny2-ny)
        return round(nx),round(ny),round(nwidth),round(nheight)
    tree = ET.parse(file)
    doc_high = float(tree.getroot().attrib["height"])
    for g in tree.findall("{http://www.w3.org/2000/svg}g"):
        if g.attrib.get("{http://www.inkscape.org/namespaces/inkscape}label","")=="col":
            for rect in g.findall("{http://www.w3.org/2000/svg}rect"):
                x = float(rect.attrib["x"])
                y = float(rect.attrib["y"])
                width = float(rect.attrib["width"])
                height = float(rect.attrib["height"])
                trans = rect.attrib.get("transform","")
                x,y,width,height = transform(x,y,width,height,trans)
                rects.append([x,y,width,height])
    return rects