import pygame
import os
import random
from featherlib.object import Object

class Food(Object):
    affect_sliders = {"diet":10}
    set_timers = {"diet":10*30}
    def __init__(self,icon,pos):
        Object.__init__(self,pygame.image.load(icon+".png"),pos)
    def eaten_by(self,bird):
        """By default all foods are just eaten and use
        affect_sliders and set_timers to affect sliders"""
        return True
    def used_on(self,bird):
        return self.eaten_by(bird)
        
class Carrot(Food):
    affect_sliders = {"diet":10}
    set_timers = {"diet":10*30}
    def __init__(self,pos):
        Food.__init__(self,"carrot",pos)
        self.food = "carrot"
        
class Lettuce(Food):
    affect_sliders = {"diet":10}
    set_timers = {"diet":10*30}
    def __init__(self,pos):
        Food.__init__(self,"lettuce",pos)
        self.food = "lettuce"

class Seeds(Food):
    affect_sliders = {"diet":random.randint(5,10)}
    set_timers = {"diet":random.randint(5,10)*30}
    def __init__(self,icon,pos):
        Food.__init__(self,icon,pos)
        self.food = "seeds"
    def eaten_by(self,bird):
        """When seeds are eaten, they might be poison and affect health"""
        print "seeds are eaten"
        if bird.is_poison(self):
            bird.sliders["health"] -= 10
        return True
        
class Seeds1(Seeds):
    affect_sliders = {"diet":random.randint(5,10)}
    set_timers = {"diet":random.randint(5,10)*30}
    def __init__(self,pos):
        Seeds.__init__(self,"seeds",pos)
        
class Seeds2(Seeds):
    affect_sliders = {"diet":random.randint(4,12)}
    set_timers = {"diet":random.randint(5,10)*30}
    def __init__(self,pos):
        Seeds.__init__(self,"seeds2",pos)