import pygame
import os
import random
from featherlib.object import Object

class ArrowUp(Object):
    tut = "This will take you to another scene."
    pri = 50
    def __init__(self,pos):
        Object.__init__(self,pygame.image.load("arrow_up.png"),pos)
    def clickme(self,hand):
        pygame.scene = pygame.kitchen
        pygame.scene.hands = [pygame.livingroom.hands[0]]
        hand.scene = pygame.scene
        
class VoiceToggle(Object):
    def __init__(self,pos):
        Object.__init__(self,pygame.image.load("voice.png"),pos)
    def clickme(self,hand):
        pygame.scene = pygame.livingroom
        for b in pygame.scene.objects:
            if hasattr(b,"voices"):
                b.voices = not b.voices
                
class Orderwife(Object):
    def __init__(self,pos):
        Object.__init__(self,pygame.image.load("store.png"),pos)
    def clickme(self,hand):
        pygame.scene = pygame.livingroom
        if isinstance(pygame.scene.hands[1].carried,Divorce):
            return
        if pygame.scene.hands[1].annoyed>=10:
            return
        pygame.scene.hands[1].wifetimer = 1
        pygame.scene.hands[1].carried = None
        pygame.scene.hands[1].moving = 0
        pygame.scene.hands[1].annoyed += 1
        
class Divorce(Object):
    def __init__(self,pos):
        Object.__init__(self,pygame.image.load("divorce.png"),pos)
        
class ArrowDown(Object):
    def __init__(self,pos):
        Object.__init__(self,pygame.image.load("arrow_down.png"),pos)
    def clickme(self,hand):
        if [1 for x in self.scene.objects if isinstance(x,Sink) and x.on]:
            print "You can't leave the sink on!"
            return
        print "clicked"
        #pygame.kitchen.hands = []
        pygame.scene = pygame.livingroom
        hand.scene = pygame.scene
        
        
class Sink(Object):
    tut = "Run your hands under the water if you are cut."
    def __init__(self,pos):
        Object.__init__(self,pygame.image.load("sink.png"),pos)
        self.on = False
    def clickme(self,hand):
        self.on = not self.on
    def draw(self,*args):
        Object.draw(self,*args)
        if self.on:
            for i in range(10):
                x = random.randint(self.pos[0]+80,self.pos[0]+90)
                y = self.pos[1]+46
                pygame.draw.line(args[0],[random.randint(40,140),random.randint(40,140),random.randint(210,230)],[x,y],[x,y+33])
            for ob in self.scene.hands:
                if ob.pos[0]<self.pos[0] or ob.pos[1]<self.pos[1]:
                    continue
                if ob.pos[0]>self.pos[0]+self.small.get_width():
                    continue
                if ob.pos[1]>self.pos[1]+self.small.get_height()/2:
                    continue
                print "healing",ob