import pygame
import os
import random
from featherlib.objects import *

class Hand(Object):
    tut = "Move with mouse. Grab/drop with left mousebutton."
    pri = 1
    def __init__(self):
        Object.__init__(self,None,[320,320])
        self.carried = None
        self.moving = 0
        self.small = pygame.image.load("hand.png")
        self.wifetimer = random.randint(800,1000)
        self.annoyed = 0
        self.divorced = False
    def click(self):
        over = None
        for o in self.scene.objects:
            if o == self:
                continue
            if self.pos[0]>=o.pos[0] and self.pos[1]>=o.pos[1] and self.pos[0]<o.pos[0]+o.size()[0] and self.pos[1]<o.pos[1]+o.size()[1]:
                over = o
                break
        if over and not self.carried:
            o.clickme(self)
        elif not over and self.carried:
            self.drop()
        elif over and self.carried:
            o.use(self,self.carried)
    def get(self,o):
        if self.carried:
            return
        if o in self.scene.objects:
            self.scene.objects.remove(o)
        self.carried = o
        print "get",self.carried
    def drop(self):
        if not self.carried:
            return
        o = self.carried
        self.scene.objects.append(o)
        o.pos = [self.pos[0]-o.size()[0]//2,self.pos[1]-o.size()[1]//2]
        o.falling = True
        self.carried = None
        print "drop",o
    def move_to(self,pos):
        self.pos = [pos[0],pos[1]]
    def move_to_point(self,dest,scene):
        self.dest = dest
        if self.moving == 0:
            if self.annoyed>10:
                key = "Divorce"
                self.divorced = True
                f = Divorce([0,0])
            else:
                key = random.choice(all_objects.keys())
                print key
                f = all_objects[key]([0,0])
            f.scene = scene
            self.get(f)
            self.moving = 1
        x = self.dest[0] - self.pos[0]
        y = self.dest[1] - self.pos[1]
        if x>0:
            self.pos[0]+=2
            x-=2
        if x<0:
            self.pos[0]-=2
            x+=2
        if y>0:
            self.pos[1]+=2
            y-=2
        if y<0:
            self.pos[1]-=2
            y+=2
        if x<=1 and x>= -1 and y<=1 and y>= -1:
            self.drop()
            if self.dest == [-50,200]:
                self.moving = 0
            self.dest = [-50,200]
    def wifetime(self,scene):
        if self.divorced:
            return
        self.wifetimer -=1
        if self.wifetimer <=0:
            self.wifetimer = random.randint(800,1000)
            self.pos = [-50,200]
            x = random.randint(50,556)
            y = random.randint(261,445)
            self.move_to_point([x,y],scene)
    def draw(self,window,usemid=True):
        if self.annoyed > 0 and self.annoyed < 10:
            self.annoyed -= 0.01
        if self.carried:
            self.carried.pos = self.pos[:]
            self.carried.draw(window,usemid=usemid)
        Object.draw(self,window,usemid=usemid)
        
class Wifehand(Hand):
    pass