import pygame
import os
import random
from featherlib.object import Object

class Radio(Object):
    tut = ""
    pri = 25
    def __init__(self,pos):
        self.decibels = 0
        self.playing = False
        self.song = None
        Object.__init__(self,pygame.image.load("radio.png"),pos)
    def clickme(self,hand):
        if hand.pos[1]<self.pos[1]+8:
            return Object.clickme(self,hand)
        if not self.playing:
            self.playing = True
            oggfiles = [x for x in os.listdir("music") if x.endswith(".ogg")]
            song = random.choice(oggfiles)
            pygame.mixer.music.load("music/"+song)
            pygame.mixer.music.play()
            self.song = song.replace(".ogg","")
        else:
            pygame.mixer.music.stop()
            self.playing = False
            self.song = None
    def draw(self,window,usemid=False):
        Object.draw(self,window,usemid=usemid)
        if self.playing:
            if self.decibels<random.randint(15,30):
                self.decibels += random.randint(1,4)
            else:
                self.decibels = random.randint(5,10)
        else:
            self.decibels = 0
        if self.decibels:
            mx,my = self.pos
            if usemid:
                mx = self.pos[0]-self.size()[0]//2
                my = self.pos[1]-self.size()[1]//2
            pygame.draw.rect(window,[0,255,0],[mx+34,my+19,self.decibels,3])