import pygame
from featherlib.objects import *
from featherlib.sliders import *

font = pygame.font.Font("cambria.ttf",22)

class Scene:
    def __init__(self,window):
        """The scene everything else goes in"""
        self.window = window
        self.bg = pygame.image.load("rect2416.png")
        self.objects = [Parrot([56,157]),Carrot([366,361]),Radio([166,400]),ArrowUp([300,200]),
                            VoiceToggle([520,440]),Orderwife([500,400])]
        self.hands = [Hand(),Wifehand()]  #Player is always the first hand
        self.hands[1].pos=[200,-30]
        self.platforms = [[0,252,640,228]]
        self.attach_objects()
    def attach_objects(self):
        """Make sure all the objects we own know about us"""
        for o in self.objects:
            o.scene = self
        for o in self.hands:
            o.scene = self
    def draw(self,window):
        window.blit(self.bg,[0,0])
        self.objects.sort(key=lambda o:o.pos[1]+o.small.get_height())
        for ob in self.objects:
            ob.draw(window)
        for o in self.objects+[x.carried for x in self.hands]:
            if hasattr(o,"sliders"):
                draw_sliders(window,o.sliders)
                break
        for hand in self.hands:
            hand.draw(window)
        #~ if window.get_width()>10:
            #~ self.objects.extend(self.hands)
            #~ self.objects.sort(key=lambda o:getattr(o,"pri",1000))
            #~ for o in self.objects:
                #~ if getattr(o,"txttime",None):
                    #~ o.txttime -= 1
                #~ if not getattr(o,"txttime",None) and getattr(o,"txt",""):
                    #~ o.txt = ""
                #~ if getattr(o,"tut","") and not getattr(o,"txt",""):
                    #~ tuts = o.tut.split(". ")
                    #~ o.txt = tuts[0]
                    #~ o.tut = ". ".join(tuts[1:])
                    #~ o.txttime = len(o.txt)*5+30
                    #~ print "set o.txt",o.txt
                #~ if getattr(o,"txt",""):
                    #~ if not o.tut and o.txttime<20:
                        #~ break
                    #~ if isinstance(o,Hand):
                        #~ if o.pos[0]<50:
                            #~ o.pos[0]=50
                        #~ if o.pos[1]<50:
                            #~ o.pos[1]=50
                    #~ window.blit(font.render(o.txt,1,[95,95,155]),[o.pos[0]-50,o.pos[1]-25])
                    #~ break
            #~ for h in self.hands:
                #~ self.objects.remove(h)
    def mousemotion(self,e):
        """Handle mousemotion events here"""
        self.hands[0].move_to(e.pos[:])
    def mousebuttondown(self,e):
        """Handle mousebuttondown events"""
        self.objects.reverse()
        self.hands[0].click()
        
def livingroom(window):
    return Scene(window)
def kitchen(window):
    s = Scene(window)
    s.bg = pygame.image.load("kitchen.png")
    s.objects = [ArrowDown([320,380]),Sink([100,150])]
    s.hands = []
    s.platforms = []
    s.attach_objects()
    return s