import pygame
import random
pygame.font.init()
font = pygame.font.Font("coure.ttf",6)

def draw_sliders(window,sliders):
    pygame.draw.rect(window,[0,0,0],[0,0,640,63])
    x = 10
    y = 5
    for key in sliders.keys():
        txt = font.render(key,1,[255,255,255])
        window.blit(txt,[x,y])
        by = y+txt.get_height()+5
        #outline
        pygame.draw.rect(window,[220,220,220],[x,by,100,15])
        width = (sliders[key]/100.0)*98.0
        if width>0:
            pygame.draw.rect(window,[0,255,0],[x+1,by+1,width,13])
        owidth = 98-width
        if owidth>0:
            pygame.draw.rect(window,[255,0,0],[x+1+width,by+1,owidth,13])
        x = max(x+txt.get_width()+5,x+105)

def music_happiness(bird):
    print bird.music_likes
    bird.badmusic = False
    bird.bobbing = False
    song = None
    for ob in bird.scene.objects:
        song = getattr(ob,"song",None)
        if song:
            break
    if not song:
        if bird.music_likes["off"]>5:
            return 2
        if bird.music_likes["off"]>0:
            return 1
        if bird.music_likes["off"]==0:
            return 0
        if bird.music_likes["off"]<0:
            return -1
        if bird.music_likes["off"]<-5:
            return -2
    else:
        if bird.music_likes[song]>5:
            bird.bobbing = True
            return 2
        if bird.music_likes[song]>0:
            bird.bobbing = True
            return 1
        if bird.music_likes[song]==0:
            return 0
        if bird.music_likes[song]<0:
            bird.badmusic = True
            return -1
        if bird.music_likes[song]<-5:
            bird.badmusic = True
            return -2
        
def toy_happiness(bird):
    bird.bored = 0
    if bird.toy_likes["newspaper"]>5:
        if not getattr(bird.bowl,"toy",None)=="newspaper":
            bird.bored = 1
            return -3
        else:
            bird.bowl.health -= 1
            if bird.bowl.health<=0:
                bird.bowl = None
            return 3
    return 0
    
def spot_happiness(bird):
    hside = "left"
    vside = "top"
    if bird.pos[0]>320:
        hside = "right"
    if bird.pos[1]>362:
        vside = "bottom"
    v = 0
    for side in [hside,vside]:
        if bird.spot_likes[side]>5:
            v += 2
        elif bird.spot_likes[side]>0:
            v += 1
        elif bird.spot_likes[side]<-5:
            v -= 2
        elif bird.spot_likes[side]<0:
            v -= 1
    return v
def happiness(bird):
    return music_happiness(bird)+toy_happiness(bird)+spot_happiness(bird)

def update_sliders(scene):
    hands = [x.carried for x in scene.hands if x.carried]
    obs = scene.objects+hands
    birds = [o for o in obs if hasattr(o,"sliders")]
    if not birds:
        return
    bird = birds[0]
    if not bird.slider_events.get("amusement",None):
        def amused(key):
            print key
            happy = happiness(bird)
            bird.sliders[key] += bird.amount[key]*happy
        bird.slider_events["amusement"] = amused
    if bird.bowl:
        if hasattr(bird.bowl,"food"):
            if bird.food_likes[bird.bowl.food]>0:
                bird.apply_ob(bird.bowl)
                bird.bowl = None
    for key in bird.slider_delays:
        bird.slider_delays[key] -= 1
        if bird.slider_delays[key]<=0:
            bird.slider_delays[key] = bird.timers[key]*30
            func = bird.slider_events.get(key,bird.slider_events.get("default"))
            if func:
                func(key)
    for key in bird.sliders:
        if bird.sliders[key]<=0:
            bird.sliders[key] = 0
        if bird.sliders[key]>100:
            bird.sliders[key] = 100