import pygame
window = pygame.display.set_mode([640,480])
pygame.mouse.set_visible(0)
pygame.mixer.init()

from featherlib import scene
pygame.livingroom = scene.livingroom(window)
pygame.kitchen = scene.kitchen(window)
pygame.scene = pygame.livingroom
clock = pygame.time.Clock()

from featherlib.sliders import *

running = 1
while running:
    dt = clock.tick(30)/1000.0
    #pygame.display.set_caption(str(1.0/dt))
    for s in [pygame.livingroom,pygame.kitchen]:
        if s != pygame.scene:
            s.draw(pygame.Surface([1,1]))
    pygame.scene.draw(window)
    update_sliders(pygame.livingroom)
    pygame.livingroom.hands[1].wifetime(pygame.livingroom)
    if pygame.livingroom.hands[1].moving == 1:
        pygame.livingroom.hands[1].move_to_point(pygame.livingroom.hands[1].dest,pygame.livingroom)
    pygame.display.flip()
    pygame.event.pump()
    for e in pygame.event.get():
        if e.type == pygame.QUIT:
            running = 0
        if e.type == pygame.MOUSEMOTION:
            pygame.scene.mousemotion(e)
        if e.type == pygame.MOUSEBUTTONDOWN:
            pygame.scene.mousebuttondown(e)